<?php

/**
 * @version    $Id: template.class.php 1 2016-05-02 15:40:18Z qinjinpeng $
 */

if(!defined('IN_SYS')) exit('Access Denied');

class template{
	
	private $tpl, $compile, $compress;
	private static $tpls=array();
	
	private $rules = array(
		//去掉//开头注释
		'/<\!--\s*\/\/.*?-->/is' => '',
		// template
		'/(<\!--|\{)\s*(template|include|require)\s+([\.\$\w\[\]\'"\/\\\]+)\s*(-->|\})/i' => '<?php include self::tpl("$3"); ?>',
		// function
		'/(\{|<\!--)(\s*[\w\:]+\(.*?\)\s*)(-->|\})/i' => array('_parse_function', -1),
		// echo 
		'/\{@?\$[\$\w\[\]\'"]+\}/si' => array('_parse_echo', 0),
		'/\{echo\s+(.+?)\}/is' => "<?php echo $1 ?>",
		// { to <!--
		'/\{\s*((if|else|elseif|foreach|sql|eval|\/if|\/foreach|\/sql).*?)\}/i' => '<!--$1 -->',
		'/<\!--\s*(if|elseif|foreach).*?-->/i' => array('_parse_tag', 0),
		// sql
		'/<\!--\s*sql\s+(.+?)\s*-->/i' => '<!--eval $_sql_result = db::select("$1");$_sql_result = tag::sql_select($_sql_result); --><!--foreach $_sql_result -->',
		'/<\!--\s*\/sql\s*-->/i' => '<!--/foreach -->',
		// if
		'/<\!--\s*if\s+(.+?)\s*-->/i' => '<?php if($1) { ?>',
		'/<\!--\s*else\s*-->/i' => '<?php } else { ?>',
		'/<\!--\s*elseif\s+(.+?)\s*-->/i' => '<?php } elseif ($1) { ?>',
		'/<\!--\s*\/if\s*-->/i' => '<?php } ?>',
		// foreach
		'/<\!--\s*foreach\s+(\S+)\s*-->/i' => '<?php tag::var_protect("IN", get_defined_vars()); $index=0; foreach($1 as \$__i => \$__value) { if(is_array(\$__value)) { $index++; foreach(\$__value as \$__k=>\$__v){ \${\$__k}=\$__v; } } ?>',
		'/<\!--\s*foreach\s+(\S+)\s+(\S+)\s*-->/i' => '<?php tag::var_protect("IN", get_defined_vars()); $index=0; foreach($1 as $2) { $index++; ?>',
		'/<\!--\s*foreach\s+(\S+)\s+(\S+)\s+(\S+)\s*-->/i' => '<?php tag::var_protect("IN", get_defined_vars()); $index=0; foreach($1 as $2 => $3) { $index++; ?>',
		'/<\!--\s*\/foreach\s*-->/i' => '<?php }; extract( tag::var_protect("OUT"), EXTR_OVERWRITE); ?>',
		// eval
		'/<\!--\s*eval\s+(.+?)\s*-->/is' => '<?php $1 ?>',
		);

	public function __construct($tpl,$tpldir,$cachedir,$prefix='')
	{
		$this->tpl = $tpldir.DS.$tpl;
		$this->compile = $cachedir.DS.$prefix.str_replace("/","_",$tpl);
	}

	public function view()
	{
		global $debug;
		if(!is_file($this->tpl)) exit("Template not exists");
		self::$tpls[] = $this->tpl;
		if ( !file_exists($this->compile) || (filemtime($this->tpl)>filemtime($this->compile) && ($debug || time()-filemtime($this->tpl)>10) ) )
		{
			$this->_compile();
		}
		return $this->compile;
	}

	private function _compile()
	{
		$data = file_get_contents($this->tpl);
		$data = $this->_parse($data);
		$dir = dirname($this->compile);
		if(!is_dir($dir)){
			@mkdir($dir,0777,true);
		}
		if(false === @file_put_contents($this->compile, $data)) exit("$this->compile file is not writable");
		@chmod($this->compile, 0774);
		return true;
	}

	private function _parse($string)
	{
		$tmpSection = array();
		$string = $this->protect_code($string, $tmpSection);

		$string = $this->_before($string);

		foreach($this->rules as $key => $value){
			if(is_array($value)){
				$string = preg_replace_callback($key, function($data) use ($value){
					$data = $value[1]>=0?$data[$value[1]]:$data;
					return tag::$value[0]( $data );
				}, $string);
			}else{
				$string = preg_replace($key, $value, $string);
			}
		}
		$string = $this->protect_code($string, $tmpSection);

		$string = $this->_after($string);

		$string = preg_replace_callback('#~([a-z0-9]{32})~#is', function($data) use ($tmpSection){
			if(isset($tmpSection[$data[1]])){
				return $tmpSection[$data[1]];
			}
			return $data[0];
		}, $string);
		return $string;
	}

	private function protect_code($string, &$tmpSection){
		return preg_replace_callback('#<\?php(.*?)\?>#is', function($data) use (&$tmpSection){
			$key = md5($data[0]);
			$tmpSection[$key] = $data[0];
			return '~'.$key.'~';
		}, $string);
	}

	private function _before($string){
		if(preg_match('#<!--\s*//\s*compress\s*on[^>]*-->#', $string)){
			$this->compress = true;
		}else{
			$this->compress = false;
		}
		$string = str_replace('__APPROOT__', '/{echo APPNAME}', $string);
		if(!defined('APPNAME') && M=='category' && !IS_MOBILE_SITE ){
			$string = str_replace('</body>', '<!--include system/global--></body>', $string);
		}
		return $string;
	}

	private function _after($string){
		//解析替换图片服务器路径
		$string = preg_replace('#(\.\.\/){1,}static\/#', '/static/', $string);

		//html压缩
		if($this->compress){
			$string = tag::compress_html($string);
		}

		$_afterString = '<?php foreach(get_class_vars(get_class($this)) as $__k => $__tmp){ if(!isset($$__k)){ $$__k = $this->$__k; } } ?>';
		$string = $_afterString.$string;

		return trim($string);
	}

	public function loaded_tpl(){
		return self::$tpls;
	}

}

?>