DROP TABLE IF EXISTS `admin`;
CREATE TABLE `admin` (
  `id` int(10) NOT NULL AUTO_INCREMENT,
  `username` varchar(20) DEFAULT NULL,
  `password` varchar(32) DEFAULT NULL,
  `salt` varchar(10) DEFAULT '',
  `realname` varchar(30) DEFAULT NULL,
  `status` tinyint(1) DEFAULT '1',
  PRIMARY KEY (`id`),
  KEY `status` (`status`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8;


DROP TABLE IF EXISTS `ads`;
CREATE TABLE `ads` (
  `id` int(11) NOT NULL AUTO_INCREMENT,
  `title` varchar(100) DEFAULT NULL,
  `content` text,
  `addtime` int(11) DEFAULT NULL,
  `status` tinyint(1) DEFAULT NULL,
  PRIMARY KEY (`id`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8;

INSERT INTO `ads` (`id`, `title`, `content`, `addtime`, `status`) VALUES
(2,	'右边栏顶部300*300',	'',	1459502838,	1),
(1,	'首页顶部banner',	'',	1459502303,	1);

DROP TABLE IF EXISTS `attachment`;
CREATE TABLE `attachment` (
  `id` int(11) NOT NULL AUTO_INCREMENT,
  `hash` varchar(255) DEFAULT NULL,
  `url` varchar(255) DEFAULT NULL,
  `addtime` int(11) DEFAULT NULL,
  PRIMARY KEY (`id`),
  KEY `hash` (`hash`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8;


DROP TABLE IF EXISTS `blacklist`;
CREATE TABLE `blacklist` (
  `id` int(11) NOT NULL AUTO_INCREMENT,
  `title` varchar(100) DEFAULT NULL,
  `burl` varchar(255) DEFAULT NULL,
  `mdurl` varchar(255) DEFAULT NULL,
  `addtime` int(11) DEFAULT NULL,
  PRIMARY KEY (`id`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8;


DROP TABLE IF EXISTS `category`;
CREATE TABLE `category` (
  `id` int(11) NOT NULL AUTO_INCREMENT,
  `cname` varchar(255) DEFAULT NULL,
  `ename` varchar(255) DEFAULT NULL,
  `keywords` text,
  `description` text,
  `type` int(255) DEFAULT NULL,
  `cjurl` varchar(255) DEFAULT NULL,
  `addtime` int(11) DEFAULT NULL,
  `updatetime` int(11) DEFAULT NULL,
  PRIMARY KEY (`id`),
  KEY `type` (`type`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8;


DROP TABLE IF EXISTS `config`;
CREATE TABLE `config` (
  `id` int(11) NOT NULL AUTO_INCREMENT,
  `varName` varchar(255) DEFAULT NULL,
  `varValue` varchar(255) DEFAULT NULL,
  PRIMARY KEY (`id`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8;

INSERT INTO `config` (`id`, `varName`, `varValue`) VALUES
(1,	'siteName',	'我的网站'),
(2, 'webHost',  ''),
(5,	'keywords',	''),
(6,	'description',	''),
(7,	'siteSwitch',	'1'),
(8,	'syncSwitch',	'1'),
(9,	'downPicture',	'1'),
(10,	'phrasesConfuse',	'0'),
(11,	'paragraphConfuse',	'0'),
(12,	'seoWord',	''),
(13,	'seoTitle',	'0'),
(14,	'seoTitle_x',	'1'),
(16,	'shieldUrl',	''),
(17,	'filterContent',	''),
(18,	'channel_time',	'3600'),
(19,	'list_time',	'86400'),
(20,	'page_time',	'31622400'),
(21,	'appkey',	''),
(22,	'appid',	''),
(23,	'mobileSwitch',	'0'),
(24,	'mobileHost',	''),
(25,	'softversion',	'1.1.4'),
(26,	'autoTitle',	'0'),
(27,	'seoWordNum',	'3'),
(28,	'seoWordScale',	'90'),
(29,	'seoConfuseScale',	'0');


DROP TABLE IF EXISTS `content`;
CREATE TABLE `content` (
  `id` int(11) NOT NULL AUTO_INCREMENT,
  `category_id` int(11) DEFAULT NULL,
  `title` varchar(60) DEFAULT NULL,
  `page_title` varchar(255) DEFAULT NULL,
  `thumb` varchar(150) DEFAULT NULL,
  `keywords` varchar(200) DEFAULT NULL,
  `description` varchar(255) DEFAULT NULL,
  `seoword` varchar(100) DEFAULT NULL,
  `confuse` tinyint(1) DEFAULT '0',
  `url` varchar(255) DEFAULT NULL,
  `hash` char(32) DEFAULT NULL,
  `pagetype` varchar(20) DEFAULT NULL,
  `addtime` int(11) DEFAULT NULL,
  `updatetime` int(11) DEFAULT NULL,
  `click` int(11) DEFAULT '1',
  PRIMARY KEY (`id`),
  KEY `hash` (`hash`) USING BTREE,
  KEY `pagetype` (`pagetype`),
  KEY `thumb` (`thumb`),
  KEY `click` (`click`),
  KEY `category_id` (`category_id`,`thumb`,`pagetype`,`click`) USING BTREE
) ENGINE=MyISAM DEFAULT CHARSET=utf8;


DROP TABLE IF EXISTS `contentbody`;
CREATE TABLE `contentbody` (
  `id` int(11) NOT NULL AUTO_INCREMENT,
  `content_id` int(11) DEFAULT NULL,
  `body` text,
  `indexes` text,
  PRIMARY KEY (`id`),
  KEY `content_id` (`content_id`),
  FULLTEXT KEY `indexes` (`indexes`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8;


DROP TABLE IF EXISTS `flink`;
CREATE TABLE `flink` (
  `id` int(11) NOT NULL AUTO_INCREMENT,
  `sitename` varchar(50) DEFAULT NULL,
  `url` varchar(180) DEFAULT NULL,
  `note` varchar(255) DEFAULT NULL,
  `addtime` int(11) DEFAULT NULL,
  `status` tinyint(4) DEFAULT '1',
  PRIMARY KEY (`id`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8;

INSERT INTO `flink` (`id`, `sitename`, `url`, `note`, `addtime`, `status`) VALUES
(3,	'流量神器',	'http://www.liuliangshenqi.com.cn/',	'系统默认',	1459480559,	1);

DROP TABLE IF EXISTS `reword`;
CREATE TABLE `reword` (
  `id` int(11) NOT NULL AUTO_INCREMENT,
  `oldword` varchar(255) DEFAULT NULL,
  `newword` varchar(255) DEFAULT NULL,
  `addtime` int(11) DEFAULT NULL,
  `type` int(255) DEFAULT NULL,
  PRIMARY KEY (`id`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8;


DROP TABLE IF EXISTS `sessions`;
CREATE TABLE `sessions` (
  `session_id` char(32) CHARACTER SET utf8 COLLATE utf8_bin NOT NULL DEFAULT '',
  `expiry` int(10) unsigned NOT NULL DEFAULT '0',
  `ip` char(15) NOT NULL DEFAULT '',
  `data` char(255) NOT NULL DEFAULT '',
  PRIMARY KEY (`session_id`),
  KEY `expiry` (`expiry`)
) ENGINE=MEMORY DEFAULT CHARSET=utf8;


DROP TABLE IF EXISTS `spider`;
CREATE TABLE `spider` (
  `id` int(11) NOT NULL AUTO_INCREMENT,
  `url` varchar(255) DEFAULT NULL,
  `addtime` int(11) DEFAULT NULL,
  `spider` varchar(255) DEFAULT NULL,
  `adddate` varchar(255) DEFAULT NULL,
  PRIMARY KEY (`id`),
  KEY `spider` (`spider`),
  KEY `addtime` (`addtime`),
  KEY `adddate` (`adddate`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8;


DROP TABLE IF EXISTS `storageservice`;
CREATE TABLE `storageservice` (
  `id` int(11) NOT NULL AUTO_INCREMENT,
  `type` varchar(20) DEFAULT NULL,
  `url` varchar(255) DEFAULT NULL,
  `status` int(11) DEFAULT NULL,
  PRIMARY KEY (`id`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8;

INSERT INTO `storageservice` (`id`, `type`, `url`, `status`) VALUES
(1,	'qiniu',	'',	0),
(2,	'upyun',	'',	0);

DROP TABLE IF EXISTS `topic`;
CREATE TABLE `topic` (
  `id` int(11) NOT NULL AUTO_INCREMENT,
  `title` varchar(60) DEFAULT NULL,
  `description` varchar(255) DEFAULT NULL,
  `addtime` int(11) DEFAULT NULL,
  `click` int(11) DEFAULT NULL,
  PRIMARY KEY (`id`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8;


DROP TABLE IF EXISTS `urlmap`;
CREATE TABLE `urlmap` (
  `id` int(11) NOT NULL AUTO_INCREMENT,
  `url` varchar(255) DEFAULT NULL,
  PRIMARY KEY (`id`),
  UNIQUE KEY `url` (`url`) USING BTREE
) ENGINE=MyISAM DEFAULT CHARSET=utf8;

